﻿using System;
namespace Strategy.Ejm1
{
    public class EncryptLogger
    {
        private EncryptionStrategy CurrEncryptionStrategy;
        private FileLogger Logger;

        public EncryptLogger(FileLogger inp_logger)
        {
            Logger = inp_logger;
            //set the default encryption strategy
            SetEncryptionStrategy(new SimpleEncryption());
        }

        public void Log(String fileName, String msg)
        {
            /*Added functionality*/
            msg = Encrypt(msg);
            /*
              Now forward the encrypted text to the FileLogger
              for storage
            */
            Logger.LogMsg(fileName, msg);

        }

        public String Encrypt(String msg)
        {
            /*
              Apply encryption using the current encryption strategy
            */
            return CurrEncryptionStrategy.Encrypt(msg);
        }

        public void SetEncryptionStrategy(EncryptionStrategy strategy)
        {
            CurrEncryptionStrategy = strategy;
        }
    }
}
